%% g2 checker
%% how does detector efficiency affect the g2 (what is the minimum efficiency that is worthwile doing the experiment)
%%  Written by Raffi & Dudy - 4/8/2013
%% adapted by Raffi  24/4/2014
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear all ;
close all ;
%% Time for experiment 20 points with 10 microseconds for each run
time = 20; % seconds
ii= round(time/20/10^-5);%

N=10;
NN=20;
g_2=zeros(N,NN);
%d_c =0.01:0.1:(n_noise-1)*0.1; % noise poisson parameter 

retrival = 0.1;%0.1:0.2:0.1+(n_retrival-1)*0.2;%%%% retrieval eficiency
dd= 0.1;%:0.05:0.05*(n_dd-1);% scan detector efficiency
lambda=0.1;%% exitation poisson parameter -Stokes

AS_eff=retrival; 


n=0;
det_eff_s=dd ;  %% detection efficiency - stokes
det_eff_as=dd ; %%% detection efficiency - AS


for d_c= 0:0.05:0.1*(N-1);% scan detector efficiency
    d_c_s=d_c ; %% noise poisson parameter for stokes
    d_c_as=d_c;%% noise poisson parameter for AS
    n=n+1;
    nn=0;
    lambda_noise(n)=d_c;



for AS_eff=0.05:0.05:0.05*NN ;%% AS retrival
   nn=nn+1;
    det_eff_s
%     P_excite=poisspdf(1,lambda) ; %% excitation probability
%     P_d_c_s=poisspdf(1,d_c_s) ; %% noise probability
    tic
  %  onee=ones(1,ii);
    
 %   for i= 1:ii;
        
  %      P_d_c_as=poisspdf(1,d_c_as).*onee ;
        p_s=poissrnd(lambda,1,ii) ; % random Poisson distribution of exciting S photon
        p_as = binornd(p_s,AS_eff,1,ii); %random binomial distribution of retrieving AS photon
        p_s_noise=p_s+poissrnd(d_c_s,1,ii) ; %% adding rand noise to stokes photons
        p_as_noise=p_as+poissrnd(d_c_as,1,ii); %%adding rand noise to AS photons
        
        
        det_s=binornd(p_s_noise,det_eff_s,1,ii) ; %%detection efficiency of total stokes photons
        det_as=binornd(p_as_noise,det_eff_as,1,ii) ; %%detection efficiency of total AS photons
        
        n_s=sum(det_s);
        n_as=sum(det_as);
        n12=sum((det_s.*det_as>=1));
        
        %n_s=n_s+det_s ;  %%Number of detected photons in stokes channel
        %n_as=n_as+det_as ; %%Number of detected photons in AS channel
        %n12=n12+ (det_s*det_as >=1) ;  %%%coincedence measurement
        
        
    
%end
    toc
    AS_vec(nn)=AS_eff ;
    g_2(n,nn)=n12*ii/n_s/n_as ; %%g(2)
    
end
end
% M = length (lambda_vec);
% for m = 1:NN
% figure (1)
% subplot(3,1,1)
% lambda = lambda_vec(m);
% hold on 
% x = 0:15;
% y = poisspdf(x,lambda);
% plot(x,y,'+','Color', [(0.5+1/2/m) 1/m (1-1/m)])
% title(['Possion ditribution for Stokes photons' ])
% xlabel('number of photons')
% ylabel('probabability')
% end

for m = 1:N
figure (1)
subplot(2,1,1)
lambda = lambda_noise(m);
hold all 
x = 0:15;
y = poisspdf(x,lambda);
plot(x,y,'+');%,'Color', [(0.5+1/2/m) 1/m (1-1/m)])
title(['Possion ditribution for Noise photons' ])
xlabel('number of photons')
ylabel('probabability')
end

for m= 1:N
figure (1)
subplot(2,1,2)
hold all 

plot(AS_vec, squeeze(g_2(m,:)));%, 'Color',[m/N m/N m/N])

title(['Increasing noise, ', num2str(dd*100,2),'% detection' ])
xlabel('Retrival efficiency (AS)')
ylabel('g2')
end



